Subject: Re: bug#47243: pr lacks -p

From: Pádraig Brady <[email-masked]>
Date: Wed, 30 Jul 2025 19:29:44 +0100

On 30/07/2025 18:31, Paul Eggert wrote:
> On 2025-07-30 04:18, Pádraig Brady wrote:
>> I'd have a slight preference for _not_ gating the isatty(STDOUT) check
>> on $POSIXLY_CORRECT.
>> We generally only use $POSIXLY_CORRECT to gate incompatible behavior.
> 
> Sure, but don't the GNU coding standards disagree with POSIX here? If we
> follow the GNU coding standards with respect to stdout, then we need a
> POSIXLY_CORRECT check.

> Or are you suggesting that we disregard the coding standards and follow
> POSIX instead? That would be a reasonable suggestion but we might want
> to ask RMS about it.

I thought POSIX might have higher priority here when it doesn't
clash with existing behavior.  As I said I hadn't a strong opinion.

> While I'm bikeshedding :-), one other thought is that if POSIXLY_CORRECT
> is not set we could also be compatible with FreeBSD, and output a bell
> before the first page if -f is specified but -p is not. I suspect that
> this is a more-useful approach (and could well be what System V did, and
> we've merely exposed a bug in POSIX here).
Didn't we discuss that, deciding we need POSIXLY_CORRECT here to gate the incompat behavior.
I.e. existing scripts may be using -f to use form feeds, and we don't
want such scripts starting to pause for their first page of output.
Or do you mean output a bell, but not pause? I can't see how that would be useful?

cheers,
Padraig